.sub ___MAIN
    __INLINE_0()
    end
.end
.sub __INLINE_0
      .globalconst int NUM_FILES = 8
      .globalconst int NUM_RANKS = 8
    __INLINE_1()
    .return()
.end
.sub _remove_queen
  .param string board
  .param int rank
  .param int file
      .local int i
      i = rank * NUM_FILES
      i = i + file
      .local int x
      x = i
      .local int y
      y = i + 1
      .local int z
      length z, board
      z = z - y
      .local string prefix
      substr prefix, board, 0, x
      .local string suffix
      substr suffix, board, y, z
      .local string temp
      temp = prefix
      concat temp, temp, " "
      concat temp, temp, suffix
      .return(temp)
      goto _remove_queen_LEAVE
_remove_queen_LEAVE:
  .return()
.end
.sub _clear_file
  .param string board
  .param int file
      .local int rank
      rank = 0
    _WHILE_0_NEXT:
      unless rank < NUM_RANKS goto _WHILE_0_LAST
    _WHILE_0_REDO:
    .namespace _WHILE_0
          board = _remove_queen(board, rank, file)
          inc rank
    .endnamespace _WHILE_0
    _WHILE_0_CONT:
      goto _WHILE_0_NEXT
    _WHILE_0_LAST:
      .return(board)
      goto _clear_file_LEAVE
_clear_file_LEAVE:
  .return()
.end
.sub _place_queen
  .param string board
  .param int rank
  .param int file
      board = _clear_file(board, file)
      .local int i
      i = rank * NUM_FILES
      i = i + file
      .local int x
      x = i
      .local int y
      y = i + 1
      .local int z
      length z, board
      z = z - y
      .local string prefix
      substr prefix, board, 0, x
      .local string suffix
      substr suffix, board, y, z
      .local string temp
      temp = prefix
      concat temp, temp, "Q"
      concat temp, temp, suffix
      .return(temp)
      goto _place_queen_LEAVE
_place_queen_LEAVE:
  .return()
.end
.sub _queen_rank
  .param string board
  .param int file
      .local int rank
      rank = 0
    _WHILE_1_NEXT:
      unless rank < NUM_RANKS goto _WHILE_1_LAST
    _WHILE_1_REDO:
    .namespace _WHILE_1
          .local int temp
          temp = _queen_at(board, rank, file)
          if temp != 1 goto _ANON_LABEL_1
          .return(rank)
          goto _queen_rank_LEAVE
        _ANON_LABEL_1:
          inc rank
    .endnamespace _WHILE_1
    _WHILE_1_CONT:
      goto _WHILE_1_NEXT
    _WHILE_1_LAST:
      .return(-1)
      goto _queen_rank_LEAVE
_queen_rank_LEAVE:
  .return()
.end
.sub _at
  .param string board
  .param int rank
  .param int file
      .local string temp
      if rank >= 0 goto _ANON_LABEL_2
      $S0 = 0
      .return($S0)
      goto _at_LEAVE
    _ANON_LABEL_2:
      if rank < NUM_RANKS goto _ANON_LABEL_3
      $S1 = 0
      .return($S1)
      goto _at_LEAVE
    _ANON_LABEL_3:
      if file >= 0 goto _ANON_LABEL_4
      $S2 = 0
      .return($S2)
      goto _at_LEAVE
    _ANON_LABEL_4:
      if file < NUM_FILES goto _ANON_LABEL_5
      $S3 = 0
      .return($S3)
      goto _at_LEAVE
    _ANON_LABEL_5:
      .local int i
      i = rank * NUM_FILES
      i = i + file
      .local int l
      length l, board
      substr temp, board, i, 1
      .return(temp)
      goto _at_LEAVE
_at_LEAVE:
  .return()
.end
.sub _queen_at
  .param string board
  .param int rank
  .param int file
      .local string temp
      temp = _at(board, rank, file)
      if temp != "Q" goto _ANON_LABEL_6
      .return(1)
      goto _queen_at_LEAVE
    _ANON_LABEL_6:
      .return(0)
      goto _queen_at_LEAVE
_queen_at_LEAVE:
  .return()
.end
.sub _free_space
  .param string board
  .param int rank
  .param int file
      .local int i
      i = 1
    _WHILE_2_NEXT:
      unless i <= file goto _WHILE_2_LAST
    _WHILE_2_REDO:
    .namespace _WHILE_2
          .local int temp_file
          .local int temp_rank
          .local int result
          temp_file = file - i
          temp_rank = rank
          result = _queen_at(board, temp_rank, temp_file)
          if result != 1 goto _ANON_LABEL_7
          .return(0)
          goto _free_space_LEAVE
        _ANON_LABEL_7:
          temp_rank = rank + i
          result = _queen_at(board, temp_rank, temp_file)
          if result != 1 goto _ANON_LABEL_8
          .return(0)
          goto _free_space_LEAVE
        _ANON_LABEL_8:
          temp_rank = rank - i
          result = _queen_at(board, temp_rank, temp_file)
          if result != 1 goto _ANON_LABEL_9
          .return(0)
          goto _free_space_LEAVE
        _ANON_LABEL_9:
          inc i
    .endnamespace _WHILE_2
    _WHILE_2_CONT:
      goto _WHILE_2_NEXT
    _WHILE_2_LAST:
      .return(1)
      goto _free_space_LEAVE
_free_space_LEAVE:
  .return()
.end
.sub _print_board
  .param string board
      .local int rank
      .local int file
      .local int temp
      rank = 7
      print "  +---+---+---+---+---+---+---+---+\n"
    _WHILE_3_NEXT:
      unless rank >= 0 goto _WHILE_3_LAST
    _WHILE_3_REDO:
    .namespace _WHILE_3
          temp = rank + 1
          $S4 = ""
          $S5 = temp
          concat $S4, $S5
          concat $S4, " |"
          print $S4
          file = 0
        _WHILE_4_NEXT:
          unless file < 8 goto _WHILE_4_LAST
        _WHILE_4_REDO:
        .namespace _WHILE_4
              .local int result
              result = _queen_at(board, rank, file)
            _IF_1_TEST:
              if result != 1 goto _IF_1_ELSE
            _IF_1_THEN:
            .namespace _IF_1_THEN
                  print " Q |"
            .endnamespace _IF_1_THEN
              goto _IF_1_LAST
            _IF_1_ELSE:
            .namespace _IF_1_ELSE
                  temp = rank + file
                  temp = temp % 2
                _IF_2_TEST:
                  if temp != 1 goto _IF_2_ELSE
                _IF_2_THEN:
                .namespace _IF_2_THEN
                      print "   |"
                .endnamespace _IF_2_THEN
                  goto _IF_2_LAST
                _IF_2_ELSE:
                .namespace _IF_2_ELSE
                      print " * |"
                .endnamespace _IF_2_ELSE
                _IF_2_LAST:
            .endnamespace _IF_1_ELSE
            _IF_1_LAST:
              inc file
        .endnamespace _WHILE_4
        _WHILE_4_CONT:
          goto _WHILE_4_NEXT
        _WHILE_4_LAST:
          print "\n"
          print "  +---+---+---+---+---+---+---+---+\n"
          dec rank
    .endnamespace _WHILE_3
    _WHILE_3_CONT:
      goto _WHILE_3_NEXT
    _WHILE_3_LAST:
      print "    A   B   C   D   E   F   G   H  \n"
_print_board_LEAVE:
  .return()
.end
.sub _new_board
      .local string board
      board = ""
      .local int rank
      rank = 0
      .local int file
      file = 0
      $S6 = ""
      concat $S6, "Making new board with "
      $S7 = NUM_RANKS
      concat $S6, $S7
      concat $S6, " ranks and "
      $S8 = NUM_FILES
      concat $S6, $S8
      concat $S6, " files...\n"
      print $S6
    _WHILE_5_NEXT:
      unless rank < NUM_RANKS goto _WHILE_5_LAST
    _WHILE_5_REDO:
    .namespace _WHILE_5
          file = 0
        _WHILE_6_NEXT:
          unless file < NUM_FILES goto _WHILE_6_LAST
        _WHILE_6_REDO:
        .namespace _WHILE_6
              concat board, board, " "
              inc file
        .endnamespace _WHILE_6
        _WHILE_6_CONT:
          goto _WHILE_6_NEXT
        _WHILE_6_LAST:
          inc rank
    .endnamespace _WHILE_5
    _WHILE_5_CONT:
      goto _WHILE_5_NEXT
    _WHILE_5_LAST:
      .local int l
      length l, board
      $S9 = ""
      concat $S9, "Board length is "
      $S10 = l
      concat $S9, $S10
      concat $S9, ".\n"
      print $S9
      .return(board)
      goto _new_board_LEAVE
_new_board_LEAVE:
  .return()
.end
.sub _main
      .local string board
      .local int rank
      .local int file
      board = _new_board()
      file = 0
      rank = 0
    _WHILE_7_NEXT:
      unless file < NUM_FILES goto _WHILE_7_LAST
    _WHILE_7_REDO:
    .namespace _WHILE_7
        _WHILE_8_NEXT:
          unless rank < NUM_RANKS goto _WHILE_8_LAST
        _WHILE_8_REDO:
        .namespace _WHILE_8
              .local int result
              result = _free_space(board, rank, file)
              if result == 1 goto _WHILE_8_LAST
              inc rank
        .endnamespace _WHILE_8
        _WHILE_8_CONT:
          goto _WHILE_8_NEXT
        _WHILE_8_LAST:
        _IF_3_TEST:
          if rank != NUM_RANKS goto _IF_3_ELSE
        _IF_3_THEN:
        .namespace _IF_3_THEN
              dec file
              rank = _queen_rank(board, file)
              board = _clear_file(board, file)
              inc rank
        .endnamespace _IF_3_THEN
          goto _IF_3_LAST
        _IF_3_ELSE:
        .namespace _IF_3_ELSE
              board = _place_queen(board, rank, file)
              inc file
              rank = 0
        .endnamespace _IF_3_ELSE
        _IF_3_LAST:
          if file < 0 goto _WHILE_7_LAST
    .endnamespace _WHILE_7
    _WHILE_7_CONT:
      goto _WHILE_7_NEXT
    _WHILE_7_LAST:
      _print_board(board)
_main_LEAVE:
  .return()
.end
.sub __INLINE_1
      _main()
    .return()
.end
